#ifndef _ENGINE_H_
#define _ENGINE_H_

#include <string>
 
enum COLOR {
  EMPTY,
  WHITE,
  BLACK,
  BLACK_TERRITORY,
  WHITE_TERRITORY,
  ALIVE,
  ERROR,
};

enum BOARDSIZE {
  MIN_BOARD = 5,
  MAX_BOARD = 25,
};

class engine {
 public:
  engine(){}
  virtual ~engine() {}

  // for GTP name command
  virtual std::string name() = 0;
  // for GTP version command
  virtual std::string version() = 0;
  // for GTP boardsize, komi, clear_board commands
  virtual void reset(int size, float komi) = 0;
  // for GTP genmove command
  virtual void genmove(int& i, int& j, COLOR color) = 0;
  // for GTP play command
  virtual void playmove(int i, int j, COLOR color) = 0;
  virtual bool legal_move(int i, int j, COLOR color) = 0;

  // for GTP undo command
  virtual void undo() = 0;

  // for GTP showboard command
  virtual COLOR get_board(int i, int j) = 0;

  // for GTP final_score command
  virtual void compute_final_status() = 0;
  virtual COLOR get_final_status(int i, int j) = 0;

  virtual void time_settings(int, int, int) = 0;
  virtual void time_left(COLOR, int, int) = 0;
};

#endif//_ENGINE_H_
